
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Affiliate_membershipsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const affiliate_memberships = await db.affiliate_memberships.create(
            {
                id: data.id || undefined,
        
        status: data.status
        ||
        null
            ,
            
        applied_at: data.applied_at
        ||
        null
            ,
            
        approved_at: data.approved_at
        ||
        null
            ,
            
        referral_code: data.referral_code
        ||
        null
            ,
            
        notes: data.notes
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await affiliate_memberships.setProgram( data.program || null, {
            transaction,
        });
        
        await affiliate_memberships.setMember( data.member || null, {
            transaction,
        });
        
        await affiliate_memberships.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        

        return affiliate_memberships;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const affiliate_membershipsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                status: item.status
            ||
            null
            ,
            
                applied_at: item.applied_at
            ||
            null
            ,
            
                approved_at: item.approved_at
            ||
            null
            ,
            
                referral_code: item.referral_code
            ||
            null
            ,
            
                notes: item.notes
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const affiliate_memberships = await db.affiliate_memberships.bulkCreate(affiliate_membershipsData, { transaction });

        // For each item created, replace relation files
        

        return affiliate_memberships;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const affiliate_memberships = await db.affiliate_memberships.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.status !== undefined) updatePayload.status = data.status;
        
        
        if (data.applied_at !== undefined) updatePayload.applied_at = data.applied_at;
        
        
        if (data.approved_at !== undefined) updatePayload.approved_at = data.approved_at;
        
        
        if (data.referral_code !== undefined) updatePayload.referral_code = data.referral_code;
        
        
        if (data.notes !== undefined) updatePayload.notes = data.notes;
        
        
        updatePayload.updatedById = currentUser.id;

        await affiliate_memberships.update(updatePayload, {transaction});

        
        
        if (data.program !== undefined) {
            await affiliate_memberships.setProgram(
              
              data.program,
              
              { transaction }
            );
        }
        
        if (data.member !== undefined) {
            await affiliate_memberships.setMember(
              
              data.member,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await affiliate_memberships.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        

        return affiliate_memberships;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const affiliate_memberships = await db.affiliate_memberships.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of affiliate_memberships) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of affiliate_memberships) {
                await record.destroy({transaction});
            }
        });


        return affiliate_memberships;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const affiliate_memberships = await db.affiliate_memberships.findByPk(id, options);

        await affiliate_memberships.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await affiliate_memberships.destroy({
            transaction
        });

        return affiliate_memberships;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const affiliate_memberships = await db.affiliate_memberships.findOne(
            { where },
            { transaction },
        );

        if (!affiliate_memberships) {
            return affiliate_memberships;
        }

        const output = affiliate_memberships.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.commissions_membership = await affiliate_memberships.getCommissions_membership({
            transaction
        });
        
        
        
        
        
        
        
        
        
        output.program = await affiliate_memberships.getProgram({
            transaction
        });
        
        
        output.member = await affiliate_memberships.getMember({
            transaction
        });
        
        
        output.organizations = await affiliate_memberships.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.affiliate_programs,
        as: 'program',
        
        where: filter.program ? {
          [Op.or]: [
            { id: { [Op.in]: filter.program.split('|').map(term => Utils.uuid(term)) } },
            {
              program_name: {
                [Op.or]: filter.program.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.users,
        as: 'member',
        
        where: filter.member ? {
          [Op.or]: [
            { id: { [Op.in]: filter.member.split('|').map(term => Utils.uuid(term)) } },
            {
              firstName: {
                [Op.or]: filter.member.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.referral_code) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'affiliate_memberships',
                        'referral_code',
                        filter.referral_code,
                    ),
                };
            }
            
            if (filter.notes) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'affiliate_memberships',
                        'notes',
                        filter.notes,
                    ),
                };
            }
            

            
            

            
            if (filter.applied_atRange) {
                const [start, end] = filter.applied_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    applied_at: {
                    ...where.applied_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    applied_at: {
                    ...where.applied_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.approved_atRange) {
                const [start, end] = filter.approved_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    approved_at: {
                    ...where.approved_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    approved_at: {
                    ...where.approved_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.status) {
                where = {
                    ...where,
                status: filter.status,
            };
            }
            


      

      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.affiliate_memberships.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'affiliate_memberships',
                        'referral_code',
                        query,
                    ),
                ],
            };
        }

        const records = await db.affiliate_memberships.findAll({
            attributes: [ 'id', 'referral_code' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['referral_code', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.referral_code,
        }));
    }

    
};

